# Generated for Telelogic Tau 4.2.0.2.13102 at Thu Apr 16 19:56:51 MEST 2009
# Licensed Materials - Property of IBM 
#  Copyright IBM Corporation 2002,2008.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands

proc HasGenerationResult el {
    foreach dep [u2::GetReferringEntities $el Supplier] {
        set gr [u2::GetEntity $dep Client]
        if { [u2::GetTaggedValue $gr "GenerationResult(..)"] != 0 }  {
            return 1
        }
    }
    return 0
}

proc EnabledIfProfileLoaded { cmd } {
### TODO: Implement!
   return 1
}

proc OnUpdateModelProject {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set project [std::GetActiveProject]
        set model   [std::GetModels -kind U2 -project $project]
        set path    [std::GetProjectPath $project]
        set agent   [u2::FindByGuid $model "@TTDCSharp@UpdateCSModel"]
        set params  [list "$path" 0]

        u2::InvokeAgent $model $agent $model params
    }
}

proc OnUpdateModelProjectForce {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set project [std::GetActiveProject]
        set model   [std::GetModels -kind U2 -project $project]
        set path    [std::GetProjectPath $project]
        set agent   [u2::FindByGuid $model "@TTDCSharp@UpdateCSModel"]
        set params  [list "$path" 1]

        u2::InvokeAgent $model $agent $model params
    }
}

proc OnUpdateCSharpProject {command} {
  set activeProject [std::GetActiveProject]
  if {$activeProject != ""} {
    set session [lindex [std::GetModels -kind U2 -project $activeProject] 0]
    set agent [u2::FindByGuid $session "@TTDCSharp@GenerateCSFiles"]
    if { 0 == $agent } {
      std::Output "Failed to find GenerateCSFiles agent\n"
      # failed to find agent
      return 0
    }
    set param [lappend param 0]
    if { [catch { u2::InvokeAgent $session $agent $session param } e ] } {
      std::Output "Error when invoking GenerateCSFiles agent : $e\n"
    }
  }
}

proc OnUpdateCSharpProjectForce {command} {
  set activeProject [std::GetActiveProject]
  if {$activeProject != ""} {
    set session [lindex [std::GetModels -kind U2 -project $activeProject] 0]
    set agent [u2::FindByGuid $session "@TTDCSharp@GenerateCSFiles"]
    if { 0 == $agent } {
      std::Output "Failed to find GenerateCSFiles agent\n"
      # failed to find agent
      return 0
    }
    set param [lappend param 1]
    if { [catch { u2::InvokeAgent $session $agent $session param } e ] } {
      std::Output "Error when invoking GenerateCSFiles agent : $e\n"
    }
  }
}

proc OnUpdateCSharpModel {command} {
    set project [std::GetActiveProject]
    set model   [std::GetModels -kind U2 -project $project]
    set path    [std::GetProjectPath $project]
    set import  [u2::FindByGuid $model "@TTDCSharp@ImportCSProject"]
    set update  [u2::FindByGuid $model "@TTDCSharp@UpdateCSModel"]
    set params  [list "$path"]
    set sel     [std::GetSelection]

    set agent $update

    if { [u2::IsKindOf $sel Package] } {
        if { [u2::GetTaggedValue $sel "cSharpImportSpecification(..)"] != 0 
          || [u2::GetTaggedValue $sel "cSharpMSVCProject(..)"] != 0 } {
            if { ![HasGenerationResult $sel] } {
                set agent $import
            }
        }
    }
    
    u2::InvokeAgent $model $agent $sel params
}

proc OnUpdateCSharpFiles {command} {
    set activeProject [std::GetActiveProject]
    if {$activeProject != ""} {
        set session [lindex [std::GetModels -kind U2 -project $activeProject] 0]
        set agent [u2::FindByGuid $session "@TTDCSharp@GenerateCSFiles"]
        if { 0 == $agent } {
            std::Output "Failed to find GenerateCSFiles agent\n"
            return 0
        }
        set param ""
        if { [catch { u2::InvokeAgent $session $agent [std::GetSelection] param } e ] } {
            std::Output "Error when invoking GenerateCSFiles agent : $e\n"
        }
    }
}


proc OnEnableCSharpElement {command} {
    set sel [std::GetSelection]
    if { [catch { set r [u2::IsKindOf $sel Entity] }] } {
        return 0
    }

    # enabled for C# file artifact...
    if { [u2::IsKindOf $sel Definition] } {
        return 1
    }
    return 0
}

# 'Generate C# source code' context menu command
# is enabled for top level model packages and generated C# artifacts
proc OnEnableGenerateContext {command} {
    set sel [std::GetSelection]
    if { [catch { set r [u2::IsKindOf $sel Entity] }] } {
        return 0
    }

    set owner [u2::GetOwner $sel]

    if { [u2::IsKindOf $sel Package] } {
        if {   [u2::IsKindOf $owner Session]
            && [u2::GetTaggedValue $sel "GenerationResult(..)"] == 0 } {
            return 1
        }
        return 0
    }

    if {   [u2::IsKindOf $sel Artifact]
        && [u2::GetTaggedValue $sel "csharpSourceFile(..)"] != 0
        && [u2::IsKindOf $owner Package]
        && [u2::GetTaggedValue $owner "GenerationResult(..)"] != 0 } {
        return 1
    }

    return 0
}


# Return active project
proc GetActiveSession {} {
    set activeProject [std::GetActiveProject]
    if { $activeProject == 0 } {
        return 0
    }
    set projects [std::GetModels -kind U2 -project $activeProject]
    foreach p $projects {
        return $p
    }
    return 0    
}


################################################################
proc Init {} {

# Non contextual update commands
    AddCommand -variable cmdUpdateModel -name "Update model" -statusmessage "Update the entire model from C# source files." -tooltip "Update model" -accelerator "Ctrl+Alt+M" -imagefile "" -OnActivateCommand OnUpdateModelProject -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateModelForce -name "Force update model" -statusmessage "Update the entire model from C# source files. Up-to-date entities are also updated." -tooltip "Force update model" -accelerator "Ctrl+Alt+Shift+M" -imagefile "" -OnActivateCommand OnUpdateModelProjectForce -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateAllFiles -name "Update source code" -statusmessage "Update C# source code with model changes." -tooltip "Update source code" -accelerator "Ctrl+Alt+S" -imagefile "" -OnActivateCommand OnUpdateCSharpProject -OnEnableCommand EnabledIfProfileLoaded
    AddCommand -variable cmdUpdateAllFilesForce -name "Force update source code" -statusmessage "Update C# source code with model changes. Up-to-date files are also updated." -tooltip "Force update source code" -accelerator "Ctrl+Alt+Shift+S" -imagefile "" -OnActivateCommand OnUpdateCSharpProjectForce -OnEnableCommand EnabledIfProfileLoaded

    AddCommand -variable cmdUpdateCSharpModel -name "Update model from C#" -statusmessage "Update C# model with source code changes" -tooltip "Update C# model" -accelerator "" -imagefile "" -OnActivateCommand OnUpdateCSharpModel -OnEnableCommand OnEnableCSharpElement
    AddCommand -variable cmdUpdateCSharpFiles -name "Update C# source code" -statusmessage "Update C# source code with model changes" -tooltip "Update C# source files" -accelerator "" -imagefile "" -OnActivateCommand OnUpdateCSharpFiles -OnEnableCommand OnEnableGenerateContext

    # Menu definitions
    
    # Add menus in reverse order since -after doesn't seem to work for nested menus
    AddMenu -variable mmnGenCSharp -commands {cmdUpdateModel cmdUpdateModelForce cmdUpdateAllFiles cmdUpdateAllFilesForce } -path { "&C\#" } -position {after &Tools}

    AddContextMenu -variable cmnCSharpElement -commands {separator cmdUpdateCSharpModel cmdUpdateCSharpFiles} -onenablemenu { OnEnableCSharpElement }
    
}

Init
