# Generated for Telelogic Tau 4.2.0.2.13102 at Thu Apr 16 19:56:51 MEST 2009
# Licensed Materials - Property of IBM 
#  Copyright IBM Corporation 2002,2008.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands

# addin parameters
namespace eval addin {

# add-in name
variable name Requirements

# add-in installation path
variable path [file join [GetInstallationDirectory] addins $name] 

# script dir
variable scriptDir [file join $path Script]

proc AddMenus {} {
	AddCommand -variable cmdReqReport -name "Basic" -statusmessage "Lists all requirements in the selected element(s)" -tooltip "List requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::RequirementsReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdReqReportDetailed -name "Detailed" -statusmessage "Lists all requirements, and their attribute values, in the selected formal module(s)" -tooltip "List requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::RequirementsReport -OnEnableCommand addin::EnableDetailedReport

	AddCommand -variable cmdNonSatisfiedReport -name "Basic" -statusmessage "Lists non-satisfied requirements in the selected element(s)" -tooltip "List non-satisfied requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdNonSatisfiedReportDetailed -name "Detailed" -statusmessage "Lists non-satisfied requirements, and their attribute values, in the selected formal module(s)" -tooltip "List non-satisfied requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdSatisfiedReport -name "Basic" -statusmessage "Lists satisfied requirements in the selected element(s)" -tooltip "List satisfied requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdSatisfiedReportDetailed -name "Detailed" -statusmessage "Lists satisfied requirements, and their attribute values, in the selected formal module(s)" -tooltip "List satisfied requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::SatisfiedReport -OnEnableCommand addin::EnableDetailedReport

	AddCommand -variable cmdNonVerifiedReport -name "Basic" -statusmessage "Lists non-verified requirements in the selected element(s)" -tooltip "List non-verified requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdNonVerifiedReportDetailed -name "Detailed" -statusmessage "Lists non-verified requirements, and their attribute values, in the selected formal module(s)" -tooltip "List non-verified requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdVerifiedReport -name "Basic" -statusmessage "Lists verified requirements in the selected element(s)" -tooltip "List verified requirements" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableReport
	AddCommand -variable cmdVerifiedReportDetailed -name "Detailed" -statusmessage "Lists verified requirements, and their attribute values, in the selected formal module(s)" -tooltip "List verified requirements (Detailed)" -accelerator "" -imagefile "" -OnActivateCommand addin::VerifiedReport -OnEnableCommand addin::EnableDetailedReport
	
	AddCommand -variable cmdDependencyReport -name "List Requirement Relations" -statusmessage "" -tooltip "" -accelerator "" -imagefile "" -OnActivateCommand addin::DependencyReport -OnEnableCommand addin::EnableReport

	AddMenu -variable mnuRequirements -commands {cmdDependencyReport} -path {Requirements} -position {after &Tools}

	AddMenu -variable mnuNonVerifiedSub -commands {cmdNonVerifiedReport cmdNonVerifiedReportDetailed} -path {Requirements "List Non-Verified Requirements"}
	AddMenu -variable mnuVerifiedSub -commands {cmdVerifiedReport cmdVerifiedReportDetailed} -path {Requirements "List Verified Requirements"}

	AddMenu -variable mnuNonSatisfiedSub -commands {cmdNonSatisfiedReport cmdNonSatisfiedReportDetailed} -path {Requirements "List Non-Satisfied Requirements"}
	AddMenu -variable mnuSatisfiedSub -commands {cmdSatisfiedReport cmdSatisfiedReportDetailed} -path {Requirements "List Satisfied Requirements"}

	AddMenu -variable mnuRequirementsSub -commands {cmdReqReport cmdReqReportDetailed} -path {Requirements "List Requirements"}
}

proc EnableDetailedReport {cmd} {
	set selectedElem [std::GetSelection]
	if { 1 != [llength $selectedElem] || ([GetKind $selectedElem] != "U2")} {
		return 0
	}
	return [expr [u2::HasAppliedStereotype $selectedElem "formalModule"] || [u2::HasAppliedStereotype $selectedElem "requirementAttributes"]]
}

proc IsUMLElement { context } {
	if {0 == [llength $context]} {
		return 0
	}

	foreach elem $context {
		if {[GetKind $elem] != "U2"} {
			return 0
		}
	}

	return 1
}

proc IsProject { context } {
	if {1 != [llength $context]} {
		return 0
	}

	if {[GetKind $context] == "project"} {
			return 1
	}

	return 0
}

proc GetModelFromSelection { } {
	set context [std::GetSelection]
	if {[IsProject $context]} {
		return [std::GetModels -project $context -kind U2]
	}
	return $context
}

proc EnableReport {cmd} {
	return [expr [IsUMLElement [std::GetSelection]] || [IsProject [std::GetSelection]]]
}

proc RequirementsReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	if {$cmd == "cmdReqReportDetailed"} {
		set type "detailed"
	}
	requirements::RequirementsReport [GetModelFromSelection] $type
}

proc SatisfiedReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	if {$cmd == "cmdSatisfiedReportDetailed" || $cmd == "cmdNonSatisfiedReportDetailed"} {
		set type "detailed"
	}
	if {$cmd == "cmdSatisfiedReport" || $cmd == "cmdSatisfiedReportDetailed"} {
		requirements::SatisfiedReport [GetModelFromSelection] $type
	} else {
		requirements::NonSatisfiedReport [GetModelFromSelection] $type
	}
}

proc VerifiedReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	set type "basic"
	set type "basic"
	if {$cmd == "cmdVerifiedReportDetailed" || $cmd == "cmdNonVerifiedReportDetailed"} {
		set type "detailed"
	}
	if {$cmd == "cmdVerifiedReport" || $cmd == "cmdVerifiedReportDetailed"} {
		requirements::VerifiedReport [GetModelFromSelection] $type
	} else {
		requirements::NonVerifiedReport [GetModelFromSelection] $type
	}
}

proc DependencyReport {cmd} { 
	source [file join $addin::scriptDir Reports.tcl]
	requirements::DependencyReport [GetModelFromSelection] 
}
############################################################################
Declare addcommand -variable cmdStartDOORS -name "Start DOORS" -statusmessage "Launch DOORS application" -tooltip "Start DOORS" -accelerator "Ctrl+Shift+D" -imagefile "../addins/Requirements/etc/StartDoors.bmp" -OnActivateCommand addin::OnStartDOORS -OnEnableCommand addin::OnEnableStartDOORS
Declare addcommand -variable cmdImportFormalModule -name "Import" -statusmessage "Import a DOORS formal module" -tooltip "Import a DOORS formal module" -accelerator "Ctrl+Shift+I" -imagefile "../addins/Requirements/etc/ImportFormalModule.bmp" -OnActivateCommand addin::OnImportFormalModule -OnEnableCommand addin::OnEnableImportFormalModule
Declare addcommand -variable cmdLocateElement -name "Locate" -statusmessage "Locate an element in DOORS" -tooltip "Locate an element in DOORS" -accelerator "Ctrl+Shift+L" -imagefile "../addins/Requirements/etc/LocateElement.bmp" -OnActivateCommand addin::OnLocateElement -OnEnableCommand addin::OnEnableLocateElement
Declare addcommand -variable cmdExportModelElement -name "Export" -statusmessage "Export to DOORS" -tooltip "Export to DOORS" -accelerator "Ctrl+Shift+X" -imagefile "../addins/Requirements/etc/ExportModelElement.bmp" -OnActivateCommand addin::OnExportModelElement -OnEnableCommand addin::OnEnableExportModelElement
Declare addcommand -variable cmdUpdate -name "Update" -statusmessage "Update" -tooltip "Update from DOORS" -accelerator "Ctrl+Shift+U" -imagefile "../addins/Requirements/etc/Update.bmp" -OnActivateCommand addin::OnUpdate -OnEnableCommand addin::OnEnableUpdateCommit
Declare addcommand -variable cmdCommit -name "Commit" -statusmessage "Commit" -tooltip "Commit changes to DOORS" -accelerator "Ctrl+Shift+C" -imagefile "../addins/Requirements/etc/Commit.bmp" -OnActivateCommand addin::OnCommit -OnEnableCommand addin::OnEnableUpdateCommit

############################################################################
#Add information to log
proc AddToLog { text } {
    std::Output $text
}

############################################################################
# Returns the session of the active project.
proc GetActiveSession {} {
    set activeProject [std::GetActiveProject]
    if { "" == $activeProject } {
		std::Output "Failed to find active project\n"
		return 0
    }
    
    set activeSession [lindex [std::GetModels -kind U2 -project $activeProject] 0]
    if { "" == $activeSession } {
		#AddToLog "Failed to find active project\n"
		return 0
    }
    
    return $activeSession
}

proc IsGoodSelection { sel } {
	if { 0 == $sel || 1 != [llength $sel] } {
		return 0
	}
	
	set kind [GetKind $sel]
	if { $kind != "U2" } {
		return 0
	}
	
	return 1
}

# return 0 if requirement addin is not activated for current project
proc IsReqAddinActivatedForElement { element } {
    if { 0 == [IsGoodSelection $element]} {
        return 0
    }
    set session [u2::GetModel $element]
	if { 0 == $session } {
        return 0
    }
    
    return [u2::FindByGuid $session "@Requirements" ]
}

proc InvokeAgentForSelectedElement1 { agentGuid param} {
    global selection
	set session [u2::GetModel $selection]
	if { 0 == $session } {
        return 0
    }
    
	set agent [u2::FindByGuid $session $agentGuid ]
	
	if { 0 == $agent } {
        AddToLog "Failed to find agent " 
        AddToLog $agentGuid 
        AddToLog "\n"
        return 0
    }
	
	global selection
	catch { u2::InvokeAgent $session $agent $selection param }
	return $param
}

proc InvokeAgentForSelectedElement { agentGuid } {
	set param 0
	set res [InvokeAgentForSelectedElement1 $agentGuid $param]
	return $res
}

proc InvokeAgentForElement { agentGuid element} {
	set session [u2::GetModel $element]
	if { 0 == $session } {
        return 0
    }
	set agent [u2::FindByGuid $session $agentGuid ]
	
	if { 0 == $agent } {
        AddToLog "Failed to find agent " 
        AddToLog $agentGuid
        AddToLog "\n"
        return 0
    }
	
	set param 0
	set params { param }
	catch { u2::InvokeAgent $session $agent $element params }
	return $params
}
############################################################################
proc IsDoorsIntegrationInstalled { } {
	set res [InvokeAgentForSelectedElement1 "@Doors@GetDoorsIntegrationKeyValue" "IsDoorsIntegrationInstalled"]
				
	if { [llength $res] == 1 } {
		if { [lindex $res 0] == "yes" } {
			return 1
		}
	}
	
	return 0
} 

proc ElementCanBeExported { } {
	set res [InvokeAgentForSelectedElement1 "@Doors@GetDoorsIntegrationKeyValue" "ElementCanBeExported"]
				
	if { [llength $res] == 1 } {
		if { [lindex $res 0] == "yes" } {
			return 1
		}
	}
	
	return 0
}

proc IsDoorsRepresentedElement { } {
	set res [InvokeAgentForSelectedElement1 "@Doors@GetDoorsIntegrationKeyValue" "IsDoorsRepresentedElement"]
				
	if { [llength $res] == 1 } {
		if { [lindex $res 0] == "yes" } {
			return 1
		}
	}
	
	return 0
}
############################################################################
proc IsExportedSurrogateModule { element } {	
	set res [InvokeAgentForElement "@Doors@IsExportedSurrogateModule" $element]
	
	if { [llength $res] == 1 } {
		if { [lindex $res 0] == 1 } {
			return 1
		}
	}
	
	return 0
}

proc IsExportedFormalModule { element } {	
	set res [InvokeAgentForElement "@Doors@IsExportedFormalModule" $element]
	
	if { [llength $res] == 1 } {
		if { [lindex $res 0] == 1 } {
			return 1
		}
	}
	
	return 0
}

proc GetCurrentOrActiveSession {} {
    global selection
    
    set session 0
    #try to use selected element
    if { 0 != [IsReqAddinActivatedForElement $selection]} {
        set session [u2::GetModel $selection]
    }
    
    if { 0 == $session } {
	    set session [GetActiveSession]
	    
        if { 0 == $session } {
		    return 0
        }
    }
    
    return $session
}
############################################################################
## DOORS Toolbar command handlers
set EnabledDOORS 1
proc OnEnableStartDOORS {command} {
    if { 0 == [GetCurrentOrActiveSession]} {
        return 0
    }
    
    return 1
}

proc OnStartDOORS {command} {
    global selection
    
    set session [GetCurrentOrActiveSession]

	InvokeAgentForElement "@Doors@StartDOORS" $session
}

#####################################
proc OnEnableImportFormalModule {command} {
    set session [GetActiveSession]
    if { 0 == $session } {
		return 0
    }
	
	return 1
}

proc OnImportFormalModule {command} {
	set session [GetActiveSession]
    if { 0 == $session } {
		return 0
    }
    
	InvokeAgentForElement "@TTDImporters@DOORSImportWizard" $session
}

#####################################
proc OnEnableLocateElement {command} {
	global selection
	if { 0 == [IsReqAddinActivatedForElement $selection]} {
        return 0
    }
	
	return [IsDoorsRepresentedElement]
}

proc OnLocateElement {command} {
	InvokeAgentForSelectedElement "@Doors@LocateInDOORS"
}

#####################################
proc OnEnableExportModelElement {command} {
	global selection	
	if { 0 == [IsReqAddinActivatedForElement $selection]} {
        return 0
    }
	
	return [ElementCanBeExported]
}

proc OnExportModelElement {command} {
	InvokeAgentForSelectedElement "@Doors@ExportToDOORS"
}

#####################################
proc OnEnableUpdateCommit {command} {
	global selection	

	if { 0 == [IsReqAddinActivatedForElement $selection]} {
        return 0
    }

	return [expr [IsExportedFormalModule $selection] || [IsDoorsIntegrationInstalled] && [IsExportedSurrogateModule $selection] ]
}

proc OnUpdate {command} {
	InvokeAgentForSelectedElement "@Doors@UpdateFromDOORS"
}

#####################################
proc OnCommit {command} {
	InvokeAgentForSelectedElement "@Doors@CommitChangesToDOORS"
}

############################################################################
# Initialize DOORS toolbar
proc AddDoorsToolbar {} {
    AddCommand cmdStartDOORS
    AddCommand cmdImportFormalModule
    AddCommand cmdLocateElement
    AddCommand cmdExportModelElement
    AddCommand cmdUpdate
    AddCommand cmdCommit

    AddToolbar -variable "DOORS" -commands {cmdStartDOORS cmdImportFormalModule cmdLocateElement cmdExportModelElement cmdUpdate cmdCommit}
}
############################################################################
proc AddDoorsMenu {} {
	AddMenu -variable menuDoors -commands {cmdStartDOORS cmdImportFormalModule cmdLocateElement cmdExportModelElement cmdUpdate cmdCommit} -path {DOORS} -position {after &Tools}
}
############################################################################

} 

addin::AddMenus
if { $tcl_platform(platform) == "windows" } {
#Doors toolbar and doors menu available only for windows.
addin::AddDoorsToolbar
addin::AddDoorsMenu
}
