# Generated for Telelogic Tau 4.2.0.2.13102 at Thu Apr 16 19:56:51 MEST 2009
# Licensed Materials - Property of IBM 
#  Copyright IBM Corporation 2002,2008.  All Rights Reserved.
# 
# U.S. Government Users Restricted Rights:  Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
package require commands
package require dialogs

set PD "\\"

set selectedWSDLs {}
set initWSSim 1

# Set Path delimeter
if { [string compare $tcl_platform(platform) "windows"]==0 } then {
    # Windows    
    set PD "\\"
} else {
    #UNIX
    set PD "/"    
}

# return current selection (it seems std::GetSelection does not support multiple selection anymore)
proc GetSelection { } {
	global selection
	return $selection
}

# Initialize WSSim
proc InitializeWSSim { } {
    global initWSSim
    if { $initWSSim } {
        set model [GetActiveSession]
        if { $model != 0 } {
            set agent [u2::FindByGuid $model "@WSSim@Initialize"]
            if { $agent != 0 } {
                set params { }
                u2::InvokeAgent $model $agent $model params
            }
        }
    }
}

# Set addin location
set addinEtcLocation "[std::GetInstallationDirectory]${PD}addins${PD}WSSim${PD}Etc${PD}"

# Return current selection
proc getSelectionFromCommand { command } {
    set command_is_selection 0
    catch {
        if { [u2::IsKindOf $command Entity] } {
            set command_is_selection 1
        }
    }
    set result [GetSelection]
    if { $command_is_selection == 1 } {
        set result $command
    }
    return $result
}

# Report information message to the WSSim tab
proc Log { context message } {
	if { [llength $context] > 1 } {
		set context [std::GetModels -kind U2 -project [std::GetActiveProject] ]
	}
    std::Report $context -ident "WSSim" "Information" $message
}

# Report warning to the WSSim tab
proc Warning { context message } {
	if { [llength $context] > 1 } {
		set context [std::GetModels -kind U2 -project [std::GetActiveProject] ]
	}
    std::Report $context -ident "WSSim" "Warning" $message
}

# Report error to the WSSim tab
proc Error { context message } {
	if { [llength $context] > 1 } {
		set context [std::GetModels -kind U2 -project [std::GetActiveProject] ]
	}
    std::Report $context -ident "WSSim" "Error" $message
}

# Return current director according to platform rules
proc loc_pwd { } {
    global tcl_platform
    set result [pwd]
    if { [string compare $tcl_platform(platform) "windows"]==0 } then {
        # Windows    
        return [string map { "/" "\\" } $result]
    }
    return $result
}

# Return active session
proc GetActiveSession {} {
    set activeProject [std::GetActiveProject]
    if { $activeProject == 0 } {
        return 0
    }
    set projects [std::GetModels -kind U2 -project $activeProject]
    foreach p $projects {
        return $p
    }
    return 0
}

# Return generated U2 proxy package
proc GetU2ProxyPackage { wsdlPackage } {
    set refs [u2::GetReferringEntities $wsdlPackage Supplier]
    foreach ref $refs {
        if { [u2::GetTaggedValue $ref "service_api(. .)"] != 0 } {
            return [u2::GetEntity $ref Owner]
        }
    }
    return 0
}


# Make folder name for MV stubs
proc MakeFolderNameForMVStubs { context existing } {
    set result "__wssim"
    set activeProject [std::GetActiveProject]
    if { $activeProject == 0 } {
        return $result
    }    
    set instance [u2::GetTaggedValue $context "wssim_dir(. .)"]
    if { $instance == 0 } {
        set model [u2::GetEntity $context Session]
        set wssim_dirStereotype [u2::FindByGuid $model "@WSSim@wssim_dir"]
        if { $wssim_dirStereotype == 0 } {
            return $result
        }        
        set index 0
        foreach inst [u2::GetReferringEntities $wssim_dirStereotype InstanceOf] {
            incr index
        }
        set result "$result$index"
        if { $existing != 0 } {
            set result $existing
        }
        set instance [u2::New $model "InstanceExpr"]
        u2::SetEntity $context "StereotypeInstance" $instance
        u2::SetValue $instance InstanceOf "uid:@WSSim@wssim_dir"
        u2::SetTaggedValue $context "wssim_dir (. dir_name .)" "\"$result\""
    } else {
        set temp [u2::GetTaggedValue $context "wssim_dir (. dir_name .)"]
        catch {
            if { [u2::IsKindOf $temp CharstringValue] } {
                set temp [u2::GetValue $temp ValueString]
            }
        }
        set result $temp
    }
    return $result
}

# Activate default metamodel
proc ActivateDefaultMetaModel { } {   
    set models [std::GetModels -kind U2]
    set metamodel 0
    foreach m $models {
        set metamodel [u2::FindByGuid $m "@TTDMetamodel"]
    }
    if { $metamodel != 0} {
        u2::SelectMetaModel $metamodel
    }
}

# Activates addin
proc ActivateAddin { addin } {
    set model [GetActiveSession]
    set context $model
    set agent [u2::FindByGuid $model "@TTDAgent@AddinManager"]
    set params [list "activate" $addin ""]
    set result [catch { u2::InvokeAgent $model $agent $context params } ]
    return $result
}

# Invokes wssim_GenerateU2Proxy agent
proc InvokeGenerateU2Proxy { context } {
    set model [GetActiveSession]
    set agent [u2::FindByGuid $model "@WSSim@GenerateU2Proxy"]
    set params { }
    set result [catch { u2::InvokeAgent $model $agent $context params } ]
    return $result
}

# Invokes wssim_GenerateMVStubs agent
proc InvokeGenerateMVStubs { context } {
    global selectedWSDLs
    set model [GetActiveSession]
    set agent [u2::FindByGuid $model "@WSSim@GenerateMVStubs"]
    set params { }    
    if { [llength $selectedWSDLs] > 1 } {
        lappend params $selectedWSDLs
    }    
    set result [catch { u2::InvokeAgent $model $agent $context params } ]    
    return $result
}

# Invokes wssim_GenerateTemplateModel agent
proc InvokeGenerateTemplateModel { context } {
    set model [GetActiveSession]
    set agent [u2::FindByGuid $model "@WSSim@GenerateTemplateModel"]
    set params { }    
    if { [llength $context] > 1 } {
        set selection { }
        foreach element $context {
            lappend selection $element
        }
        lappend params $selection
    } else {
        lappend params $context
    }
    set result [catch { u2::InvokeAgent $model $agent $model params } ]
    return $result
}

# Generate WSDL UML API
proc onActivateCommandGenerateU2Proxy { command } {    
    InitializeWSSim
	
	ActivateDefaultMetaModel
    
    set context [getSelectionFromCommand $command]
    Log $context "Generating U2Proxy"
    if { [InvokeGenerateU2Proxy $context] != 0 } {
        Error $context "Could not generate UML proxy classes for the web service definition."
        return
    }
	
    Log $context "Generation completed"
}

# Check if onActivateCommandGenerateU2Proxy is enabled for given selection 
proc onEnableGenerateU2Proxy { command } {

    set context [GetSelection]    
    set verdict 0
    catch {
        if { [u2::IsKindOf $context Package] } {
            if { [u2::GetTaggedValue $context "wsdlPackage(. .)"] != 0 } {
                set verdict 1
            }
        }
    }
    
    return $verdict
}

# Check is UML API + MV stubs can be generated for the current selection
proc onEnableGenerateU2ProxyAndMVStubs { command } {
    if { [onEnableGenerateU2Proxy $command] } {
        return 1
    }
    
    set verdict 0
    set context [GetSelection]
    # Allow generation of MV stubs for multiple selection
    catch {
        set has_wsdl_package 0
        foreach element $context {            
            if { [u2::IsKindOf $element Package] } {
                if { [u2::GetTaggedValue $element "wsdlPackage(. .)"] != 0 } {                    
                    set has_wsdl_package 1
                    continue
                } else {                    
                    return 0
                }
            } else {
                return 0
            }
        }
        # all selected elements are wsdlPackages
        set verdict $has_wsdl_package
    }
    
    return $verdict
}


# Return WSDL package from U2 proxy package
proc GetWSDLPackage { context } {
    set outgoindDeps [u2::GetEntities $context ClientDependency]    
    foreach dep $outgoindDeps {
        if { [u2::GetTaggedValue $dep "service_api(. .)"] != 0 } {
            return [u2::GetEntity $dep Supplier]
        }
    }
}

# Return URI of the WSDL 
proc GetWSDLLocation { context } {
    set result ""
    catch {
        set outgoindDeps [u2::GetEntities $context ClientDependency]    
        foreach dep $outgoindDeps {
            if { [u2::GetTaggedValue $dep "service_api(. .)"] != 0 } {
                set wsdlPackage [u2::GetEntity $dep Supplier]
            }
        }
        if { $wsdlPackage != 0 } {    
            set incomingDeps [u2::GetReferringEntities $wsdlPackage Supplier]
            foreach dep $incomingDeps {        
                set owner [u2::GetEntity $dep Owner]
                if { [u2::IsKindOf $owner Artifact] } {
                    set result [u2::GetTaggedValue $owner "wsdlFile (. path .)"]
                    break
                }
            }
        }
        set result [string trim [string map {"\\\\" "\\"} [u2::Unparse $result] ] "\""]
    }
    if { [file exists $result] } {
        return $result
    }
    if { ([string first "http:" $result] == 0) ||
         ([string first "https:" $result] == 0) ||
         ([string first "ftp:" $result] == 0) } {
         return $result
    }
    return 0
}

proc GenFileForMV { targetDir } {
    # Generate *.h file
    set mv_h [open "${targetDir}mv.h" "w+"]
    set files [glob -directory $targetDir "soapStub.h"]
    set files [concat $files [glob -directory $targetDir "soapex.h"] ]
    puts $mv_h "/*********************************************************"
    puts $mv_h "    Auto-generated code. PLEASE, DO NOT MODIFY IT!"
    puts $mv_h "*********************************************************/"
    puts $mv_h ""
    puts $mv_h ""    
    foreach f $files {
        set cname [string map { "\\" "\\\\" "/" "\\\\" } $f]
        puts $mv_h "#include \"$cname\""
    }
    close $mv_h
    
    
    # Generate *.c file
    set files [glob -directory $targetDir "*.c"]
    set nsmaps [glob -directory $targetDir "*.nsmap"]
    
    # add the first nsmap file only
    foreach nsmap [glob -directory $targetDir "*.nsmap"] {
        lappend files $nsmap
        break
    }    
    set mv_c [open "${targetDir}mv.c" "w+"]
    puts $mv_c "/*********************************************************"
    puts $mv_c "    Auto-generated code. PLEASE, DO NOT MODIFY IT!"
    puts $mv_c "*********************************************************/"
    puts $mv_c ""
    puts $mv_c ""
    puts $mv_c "#define WITH_OPENSSL"
    foreach f $files {
        set cname [string map { "\\" "\\\\" } $f]
        puts $mv_c "#include \"$cname\""
    }
    close $mv_c
}

proc GenTpmFile { targetDir } {
    global PD addinEtcLocation errorCode
    set tpmFileName "${targetDir}soap.tpm"    
    set f [open $tpmFileName "w+"]
    catch {
        puts $f "USERLIBRARIES = \"${addinEtcLocation}libeay32.lib\" \"${addinEtcLocation}ssleay32.lib\""
        puts $f "USERTARGET = \"${targetDir}mv\$(sctOEXTENSION)\" \"${targetDir}logreader\$(sctOEXTENSION)\""
        puts $f "\"${targetDir}mv\$(sctOEXTENSION)\": \"${targetDir}mv.c\" OpenSSLDlls"
        puts $f "  \$(sctCC) @<<"
        puts $f "  \$(sctCPPFLAGS) \$(sctCCFLAGS)"
        puts $f "  \$(sctIFDEF) /I\"${addinEtcLocation}include\""
        puts $f "  /Fo\"${targetDir}mv\$(sctOEXTENSION)\""
        puts $f "  \"${targetDir}mv.c\""
        puts $f "<<"
        puts $f ""
        puts $f ""
        puts $f "\"${targetDir}logreader\$(sctOEXTENSION)\": \"${targetDir}logreader.c\""
        puts $f "  \$(sctCC) @<<"
        puts $f "  \$(sctCPPFLAGS) \$(sctCCFLAGS)"
        puts $f "  \$(sctIFDEF) /I\"${addinEtcLocation}include\""
        puts $f "  /Fo\"${targetDir}logreader\$(sctOEXTENSION)\""
        puts $f "  \"${targetDir}logreader.c\""
        puts $f "<<"
        puts $f ""
        puts $f ""        
        puts $f "OpenSSLDlls:"
        puts $f "\t copy /y \"${addinEtcLocation}libeay32.dll\" ."
        puts $f "\t copy /y \"${addinEtcLocation}ssleay32.dll\" ."
        puts $f "\t copy /y \"${addinEtcLocation}cacerts.pem\" ."
        puts $f ""
        puts $f ""
        puts $f "clean_user_objs:"
        puts $f "\t\$(sctRM) \$(USERTARGET) libeay32.dll ssleay32.dll cacerts.pem"
    }
    close $f    
    return $tpmFileName
}

proc ApplyCApplStereotype { context targetDir } {
    set u2path [string map { "\\" "\\\\" } "${targetDir}mv.h"]
    set model [GetActiveSession]
    set instance [u2::GetTaggedValue $context "\'C Application\' (. .)"]
    if { $instance == 0 } {
        set instance [u2::New $model "InstanceExpr"]
        u2::SetEntity $context "StereotypeInstance" $instance
        u2::SetValue $instance InstanceOf "ref:\'C Application\'"    
    }
    u2::SetTaggedValue $context "\'C Application\'(. includedFile .)" "\"$u2path\""
}

# Calls gSOAP utils to generate client code
proc call_gSOAPUtils { init wsdls } {
    global PD addinEtcLocation errorCode U2
    
    # setting context to U2
    set context $U2
    
    # check that wsdls contains atleast one WSDL package
    if { [llength $wsdls] == 0 } {
        return
    }
    
    # Initialize error reporter
    if { $init != 0 } {
        InitializeWSSim
    }
    
    # Get project directory
    set prjDir [file dirname [std::GetProjectPath [std::GetActiveProject] ] ]
    if { $PD == "\\" } {
        set prjDir [string map { "/" "\\"} $prjDir]
    }
    
    # Set wssimdir stereotype and collect wsdl file pathes
    set wssimdirName 0
    set wsdlFileLst { }
    set u2proxyPackages { }
    foreach wsdl $wsdls {
        set u2proxy [GetU2ProxyPackage $wsdl]
        if { $u2proxy != 0 } {
            set wssimdirName [MakeFolderNameForMVStubs $u2proxy $wssimdirName]
            lappend wsdlFileLst [GetWSDLLocation $u2proxy]
            lappend u2proxyPackages $u2proxy
        }
    }
        
    # Check location of wsdl files
    if { [llength $wsdlFileLst] == 0 } {
        Error $U2 "Could not detect location of WSDL file(s)."
        return
    }
    
    # Convert list of wsdl files to string
    set wsdlFile ""
    set first 1
    foreach f $wsdlFileLst {
        if { $first == 1 } {
            set first 0
            set wsdlFile "$f"
        } else {
            set wsdlFile "$wsdlFile $f"
        }
    }
    
    # set path to WSSim directory
    set wssimdir "${prjDir}${PD}$wssimdirName"        
    Log $context "Generating MV Stubs to $wssimdir"
    
    
    # Clear existing directory
    if { [file exists $wssimdir] } {
        Log $context "    Clearing directory ${wssimdir}"
        foreach f [glob -directory ${wssimdir} "*.*"] {
            if { [ catch { file delete $f } ] } {
                Error $context "    Cannot delete file ${f}"
            }
        }        
    } else {    
        # Create directory for generated C stubs
        Log $context "    Creating directory ${wssimdir}"           
        file mkdir $wssimdir    
    }
    
    # copy stdsoap2.c, stdsoap2.h and other necessary files to this directory
    file copy -force "$addinEtcLocation${PD}stdsoap2.h" "$wssimdir${PD}stdsoap2.h"
    file copy -force "$addinEtcLocation${PD}stdsoap2.c" "$wssimdir${PD}stdsoap2.c"
    file copy -force "$addinEtcLocation${PD}soapex.h" "$wssimdir${PD}soapex.h"   
    
    # generate c-stubs
    set targetDir "${wssimdir}${PD}"    
    set wsdl2h "${addinEtcLocation}wsdl2h.exe"
    set soapcpp2 "${addinEtcLocation}soapcpp2.exe"    
    catch { 
        Log $context "    Calling $wsdl2h on '$wsdlFile'"
        set tmp [list exec $wsdl2h -c -ntlog -u -w -o ${targetDir}service.h]
        foreach wsdlFile $wsdlFileLst {
            lappend tmp $wsdlFile
        }                
        eval $tmp
        #exec $wsdl2h -c -ntlog -u -w -o ${targetDir}service.h $wsdlFile
    }
    if { $errorCode != "NONE" } {
        Error $context "    There were errors while calling wsdl2h application"
        Error $context "    $errorCode"
        return 
    }    
    catch {
        Log $context "    Calling $soapcpp2 on '${targetDir}service.h'"
        exec $soapcpp2 -1 -C -L -c -w -x -t -d${targetDir} ${targetDir}service.h
    }
    if { $errorCode != "NONE" } {
        Error $context "    There were errors while calling soapcpp2 application"
        Error $context "    $errorCode"
        return 
    }
    catch {
        Log $context "    Deleting temporary files"
        file delete -force ${targetDir}service.h
    }
    
    # Delete nsmap file related to SOAP 1.2 binding    
    catch {
        Log $context "    Deleting SOAP 1.2 files"
        set soap12Files [glob -directory $targetDir "*12.nsmap"]
        foreach f $soap12Files {
            file delete -force $f
        }
    }
    
    # Generate file for MV
    GenFileForMV $targetDir
    
    # Copy other files to wssim directory
    file copy -force "$addinEtcLocation${PD}logreader.c" "$wssimdir${PD}logreader.c"
    
    # Generate tpm file
    Log $context "    Generating makefile template for MV"
    set tpmFile [GenTpmFile $targetDir]
    Log $context "    Makefile template $tpmFile is successfully generated"
    
    # Set C Application stereotype to proxy packages
    foreach pkg $u2proxyPackages {
        Log $context "    Applying 'C Application' stereotype to [u2::GetValue $pkg Name]"
        ApplyCApplStereotype $pkg $targetDir
    }
}

# Generates C stubs for MV
proc do_onActivateCommandGenerateMVStubs { context init wsdls } {        
    
    # call gSOAP utils 
    # NOTE: is number of wsdls > 1, it will be called from another place
    if { [llength $wsdls] == 0 } {        
        lappend wsdls [GetWSDLPackage $context]        
    }
    if { [llength $wsdls] == 1 } {
        call_gSOAPUtils $init $wsdls
    }
    
    # Invoke agent
    Log $context "    Generating inline code"
    if { [InvokeGenerateMVStubs $context] != 0 } {
        Error $context "Could not generate MV stub code."
        return
    }
    
    Log $context "Generation completed."
}

proc onActivateCommandGenerateMVStubs { command } {
    global selectedWSDLs
    set context [GetSelection]
    do_onActivateCommandGenerateMVStubs $context 1 $selectedWSDLs
}

# Check if onActivateCommandGenerateMVStubs is enabled for give selection
proc do_onEnableGenerateMVStubs { context } {
    set verdict 0
    catch {
        if { [u2::IsKindOf $context Package] } {
            if { [u2::GetTaggedValue $context "service_api(. .)"] != 0 } {
                set verdict 1
            }
        }
    }
    return $verdict
}

proc onEnableGenerateMVStubs { command } {
    set context [GetSelection]
    return [do_onEnableGenerateMVStubs $context]
}

# Generates sample template model
proc onActivateCommandGenerateTemplateModel { command } {
    global U2
    
    InitializeWSSim
    
    set context [GetSelection]
    Log $U2 "Generating Sample template model"
    if { [InvokeGenerateTemplateModel $context] != 0 } {
        Error $U2 "Could not generate sample template model for web-service proxy package."
        return
    }
    Log $U2 "Generation completed"

}

# Check if WSSim context menu is enabled
proc onEnableWSSimContextMenu { command } {
    
    # Enable if Generate U2 proxy command is available on the current selection
    if { [onEnableGenerateU2Proxy $command] } {
        return 1
    }
    
    # Enable if Generate MV Stubs command is available on the current selection
    if { [onEnableGenerateMVStubs $command] } {
        return 1
    }
    
    # Enable if Generate UML API + MV Stubs command is available on the current selection
    if { [onEnableGenerateU2ProxyAndMVStubs $command] } {
        return 1
    }
    
    # Enable if Generat Template Model command is available on the current selection
    if { [onEnableGenerateTemplateModel $command] } {
        return 1
    }
    return 0
}

# Generates UML API/MV Stubs on multiple selection
proc GenerateUMLApiForMultipleSelection { selection } {
    global selectedWSDLs U2
    
    foreach wsdl $selection {
        lappend selectedWSDLs $wsdl
    }
        
    Log $U2 "Generating UML Api and MV stubs for calling web-services."
    
    # Generate proxy model and MV stubs
    foreach pack $selection {
        # Generate/update U2 proxy package
        onActivateCommandGenerateU2Proxy $pack
        set u2ProxyPackage [GetU2ProxyPackage $pack ]
        
        # Generate MV stub code
        if { $u2ProxyPackage != 0 } {
            do_onActivateCommandGenerateMVStubs $u2ProxyPackage 0 $selectedWSDLs
        }
    }
    
    # Generate gSOAP stuff    
    if { [llength $selectedWSDLs] > 1 } {        
        call_gSOAPUtils 0 $selectedWSDLs
    }
    
    Log $U2 "Done."
}

# Generate or update U2 proxy and MV stubs
proc onActivateCommandGenerateProxyAndMVStubs { command } {
    global selectedWSDLs
    
	ActivateDefaultMetaModel
	
    # If several packages are selected, use another algorithm
    if { [llength [GetSelection]] > 1 } {
        GenerateUMLApiForMultipleSelection [GetSelection]
    } else {
        # Generate/update U2 proxy package
        onActivateCommandGenerateU2Proxy $command
        set u2ProxyPackage [GetU2ProxyPackage [getSelectionFromCommand $command] ]
        
        # Generate MV stub code
        if { $u2ProxyPackage != 0 } {
            do_onActivateCommandGenerateMVStubs $u2ProxyPackage 0 $selectedWSDLs
        }
    }
}

# Check that template model can be generate for given selection
proc onEnableGenerateTemplateModel { command } {    
    set context [GetSelection]
    if { [do_onEnableGenerateMVStubs $context] } {
        return 1
    }    
    set verdict 0
    if { [llength $context] > 1 } {
        foreach e $context {
            if { [do_onEnableGenerateMVStubs $e] == 0 } {
                return 0
            } else {
                set verdict 1
            }
        }
    }
    return $verdict
}

# Create context menus
proc CreateMenu { } {

    AddCommand -variable cmdGenerateU2Proxy -name "Generate pure UML Web Service Interface" -statusmessage "Generate pure UML Service Interface." -tooltip "Generate pure UML Service Interface" -imagefile "" -OnActivateCommand onActivateCommandGenerateU2Proxy -OnEnableCommand onEnableGenerateU2Proxy
    
    AddCommand -variable cmdGenerateTemplateModel -name "Generate Web Service Consumer" -statusmessage "Generate Web Service Consumer for UML Service Interface." -tooltip "Generate Web Service Consumer" -imagefile "" -OnActivateCommand onActivateCommandGenerateTemplateModel -OnEnableCommand onEnableGenerateTemplateModel    
    
    AddCommand -variable cmdGenerateProxyAndMVStubs -name "Generate/Update UML Web Service Interface" -statusmessage "Generate/Update UML Web Service Interface for calling web service(s)." -tooltip "Generate/Update UML Web Service Interface" -imagefile "" -OnActivateCommand onActivateCommandGenerateProxyAndMVStubs -OnEnableCommand onEnableGenerateU2ProxyAndMVStubs
            
    # Add context menu with commands: Generate UML Api, Generate/Update UML API for MV, Generate Template Model
    AddContextMenu -variable cmnWSSim -commands { separator cmdGenerateU2Proxy cmdGenerateProxyAndMVStubs cmdGenerateTemplateModel } -onenablemenu { onEnableWSSimContextMenu }    

}

# look for @WSSim@generate_api_for_mv stereotype on session and invoke corresponding command
proc runOnInitTask { model } {
    global selectedWSDLs initWSSim
    
    InitializeWSSim
    set printLog 0
    
    set initWSSim 0
    set selectedWSDLs { }
    set wsdl { }
    set generateTemplateModel 0
    
    foreach s [u2::GetEntities $model HiddenStereotypeInstance] {
        set guid [u2::GetValue $s InstanceOf]        
        if { $guid == "uid:@WSSim@generate_api_for_mv" } {
            foreach e [u2::GetEntities $s Expression] {
                if { [u2::IsKindOf $e BinaryExpr] } {
                    set lvalue [u2::GetEntity $e LeftOperand]
                    set rvalue [u2::GetEntity $e RightOperand]
                    if { [u2::IsKindOf $rvalue ListExpr] } {
                        foreach w [u2::GetEntities $rvalue Expression] {
                            lappend wsdl [u2::GetValue $w ValueString]                            
                        }
                    } else {
                        set generateTemplateModel 1
                    }
                }
            }
        }
    }
    
    # look for WSDL packages with specified guid
    foreach g $wsdl {
        set pack [u2::FindByGuid $model $g]
        set printLog 1
        lappend selectedWSDLs $pack
    }
        
    if { $printLog } {
        Log $model "Generating UML Api and MV stubs for calling web-services."
    }
    
    # Generate proxy model and MV stubs
    foreach pack $selectedWSDLs {
        onActivateCommandGenerateProxyAndMVStubs $pack
    }
    
    # Generate gSOAP stuff    
    if { [llength $selectedWSDLs] > 1 } {        
        call_gSOAPUtils 0 $selectedWSDLs
    }
    
    # Generate template model
    if { $generateTemplateModel } {
        set api { }
        foreach wsdl $selectedWSDLs {
            set proxy [GetU2ProxyPackage $wsdl]
            lappend api $proxy
        }
        InvokeGenerateTemplateModel $api
    }
    
    if { $printLog } {    
        Log $model "Done."
    }
    
    # clean up global variable
    set selectedWSDLs { }
    set initWSSim 1
}

CreateMenu
ActivateAddin "ModelVerifier"
ActivateAddin "WSDL"
ActivateDefaultMetaModel

if { $U2 != 0 } {

    set context $U2
	if { [llength $context] > 1 } {
		set context [std::GetModels -kind U2 -project [std::GetActiveProject] ]
	}	    
    runOnInitTask $context
}
